#  Prelude module (prelude.io)
#  Amalthea standard Io library
#  (c)2002 Martin Sandin (msandin@hotmail.com)
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

import tuple.
import iterator.
import list.
import order.
import string.
import int.

export

  # Tuple
  Tuple
  fst
  snd
  both
  TupleIterator
  TuplePrinter
  string_of_tuple
  arg_as_tuple
  apply_tupled
  apply_separate
  curry_func
  Triple

  # Iterator
  for_each
  combine
  map
  accumulate
  fold
  collect
  reverse
  Range
  RangeFrom
  is_empty
  length
  take
  iterate
  head
  tail
  concat
  append
  
  # List
  Nil
  cons
  print_list
  string_of_list
  List_of_1 List_of_2 List_of_3 List_of_4
  List_of_5 List_of_6 List_of_7 List_of_8
  
  # Order
  Order
  order_before
  order_same
  order_after
  
  # String
  concat_strings
  ^
  print_string
  print_string_
  int_of_string
  substring
  string_length
  
  # Int
  +
  -
  *
  /
  >
  <
  print_int
  print_int_
  string_of_int
  
  # Local
  terminate
  id
  =
  .

# Interface
#  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #

primitive terminate: terminate.
primitive =: eq.
declare id: -> x return;
  return x.


# Demo
#  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #

print_string "Amalthea standard Io library: Prelude module";
terminate
